<?
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004-2006 ZoneO-soft, S. Merkel (dude@zoneo.net)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/

$version = "1.2beta2";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<title>phpTrafficA helpdesk</title>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<META NAME="AUTHOR" CONTENT="phpTrafficA">
<link rel="stylesheet" href="main.css" type="text/css">
</head>
<div class="help">
<div class="top"><div align="right"><a href="javascript:window.close();">Close window</a></div>
<h1>phpTrafficA helpdesk</h1>
</div>

<div class='text'>
<ul>

<li><A name="blist"></A><strong>Black list</strong>: this forms is used to blacklist buggy referrers. For instance, they are a few search engines that do not allow the extraction of the keywords used to access the website, they can not be included in the search engines statistics, but they are not and should not be counted as referrers. This function is also used to ban sites that perform <A href="http://en.wikipedia.org/wiki/Referer_spam">referrer spam</A>.</li>

<li><A name="domain"></A><strong>Domain</strong>: Enter the root of the domain you want to track, something like <code>myserver.net/mydirectory/</code>.</li>

<li><A name="savehost"></A><strong>Latest hosts</strong>: phpTrafficA keeps a table with the full information of the latest visitors. After some time they are simply deleted in order to save space and information is kept in a processed form. This table is used in the <code>Latest visits</code> tab and for data processing in the <code>Path Analysis</code>. If you want to have more hosts included in those functions, increase the number of saved hosts. phpTrafficA might become extremely slow with large tables.</li>

<li><A name="oslist"></A><strong>OS list</strong>: list of operating systems. This table displays the list of operating systems and how to detect them in the browser identification. Each line contains an identification string followed by the OS name, separated by the symbol <code>|</code>. This table is updated with phpTrafficA upgrades.</li>

<li><A name="public"></A><strong>Public</strong>: all visitors are allowed to statistics related to <code>public</code> domains. Statistics for <code>private</code> domains are only available when you log in.</li>

<li><A name="selist"></A><strong>Search engine list</strong>: this table displays the list of search engines, how to detect them, and how to extract keywords in the referrer string. Each line contains information for one search engine, separated by the symbol <code>|</code>. First item is a name, second item is a string used to detect the search engine in the referrer url, and third item is the variable this search engine uses to pass keywords (separated by the symbol <code>:</code> for multiple possibilities). For instance, a search in google will be detected with the URL <code>google.com</code> and the variable <code>q</code>. This table is updated with phpTrafficA upgrades.</li>

<li><A name="table"></A><strong>Table</strong>: base name for sql tables. We create several table for each website tracked by phpTrafficA. Their name always start with the string provided here.</li>

<li><A name="trim"></A><strong>Trim URL</strong>: if this this set to <code>true</code>, URL used in the statistics will be trimmed. For instance, <code>index.php?lang=fr</code> and <code>index.php?lang=en</code> will all be stored as <code>index.php</code>. This is the default behavior in phpTrafficA. Be careful if you decide to keep the full URL for your statistics as the number of combinations of URL can be immense for fully dynamic websites. Moreover, <strong>it is not recommended to change this parameter once you have used phpTrafficA for a while</strong>.</li>

<li><A name="wblist"></A><strong>Web browser list</strong>: list of web browsers. This table displays the list of web browsers and how to detect them in the browser identification. Each line contains an identification string followed by the browser name, separated by the symbol <code>|</code>. This table is updated with phpTrafficA upgrades.</li>

</ul>
</div>
</div>
<div id='sign'><a href="http://soft.zoneo.net/phpTrafficA/">phpTrafficA</a> <?echo $version;?> &copy; 2004-2006, ZoneO-soft</div>
</body>
</html>
