<?
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004-2006 ZoneO-soft, S. Merkel (dude@zoneo.net)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/

/***** TODO LIST
- rework visit duration
- rework visitor retention
******/

include ("./Php/funct.inc.php");
$timestart = getmicrotime();
// Use cache for output; disabled, it can crash if your server is too slow.
//ob_start();
include ("./Php/config_sql.php");
include ("./Php/config.php"); 
include ("./Php/sites.php"); 
include ("./Php/login.inc.php");  
$version = "1.2beta2";
$DEBUG = 0;
$DEMO = 0; // Set to 1 for demo mode
if ($DEMO) {
        $demo = " demo";
} else {
        $demo = "";
}
if (!isset($mode) or $mode == "") {
	$mode = $_GET["mode"];
	if ($mode == "") { $mode = $_POST["mode"];}
}
if (!isset($sid) or $sid=="") {$sid = $_GET["sid"];}
// Trying to login or logout and make sure we are
if ($mode == "login") {
	logIn();
} elseif ($mode == "logout") {
	logOut();
}
$isLoggedIn = isloggedin ();
// Dealing with cookies
if (($mode=="addcookie") && ($isLoggedIn) && (!$DEMO)) {
	SetCookie("phpTrafficA","Admin",time()+100000000,"/","",0);
	header('Location: index.php?mode=cookie');
}
if (($mode=="removecookie") && ($isLoggedIn) && (!$DEMO)) {
	SetCookie("phpTrafficA","",time()+100000000,"/","",0);
	header('Location: index.php?mode=cookie');
}
// Clean up temp files directory
tmpclean();
// Check that the request is allowed otherwise deny it
if (($mode=="setup") && (!$isLoggedIn)) $mode = "main";
if (($mode=="reminder") && (!$isLoggedIn)) $mode = "main";
if (($mode=="licence") && (!$isLoggedIn)) $mode = "main";
if (($mode=="about") && (!$isLoggedIn)) $mode = "main";
if (($mode=="cookie") && (!$isLoggedIn)) $mode = "main";
if (($mode=="stats") && (!$isLoggedIn) && (!$sites[$sid]['public'])) $mode = "main";
// Setting page titles
if ($mode=="setup") {
	$title = "phpTrafficA -- web statistics";
	$subtitle = "phpTrafficA$demo: setup";
} else if ($mode=="reminder") {
	$title = "phpTrafficA -- web statistics";
	$subtitle = "phpTrafficA$demo: reminder";
} else if ($mode=="about") {
	$title = "phpTrafficA -- web statistics";
	$subtitle = "About phpTrafficA";
} else if ($mode=="licence") {
	$title = "phpTrafficA -- web statistics";
	$subtitle = "phpTrafficA$demo: licence";
} else if ($mode=="cookie") {
	$title = "phpTrafficA -- web statistics";
	$subtitle = "phpTrafficA$demo: administrator cookie";
} else if ($mode=="stats") {
	$table = $sites[$sid]['table'];
	$domain = $sites[$sid]['site'];
	$title = "Statistics for $domain";
	$subtitle = "phpTrafficA$demo: statistics for $domain";
} else {
	$title = "phpTrafficA -- web statistics";
	$subtitle = "phpTrafficA$demo";
}
// Setting a few variables
$cachepagenameset = false; // We did not set up a cache with a list of page names yet
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<title><?echo $title;?></title>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<META NAME="AUTHOR" CONTENT="phpTrafficA">
<link rel="stylesheet" href="main.css" type="text/css">
</head>
<script type="text/javascript" language="javascript">
function help(item) {
  var file = "./help.php#"+item;
  popup=window.open(file, "Help Window", "width=350,height=250,directories=no,status=no,location=no,toolbar=no,scrollbars=yes,resizable=yes,menubar=no,copyhistory=no");
}
function banRef(sid,item) {
  var file = "./banref.php?sid="+sid+"&id="+item;
  popup=window.open(file, "Ban Referrer Window", "width=500,height=300,directories=no,status=no,location=no,toolbar=no,scrollbars=yes,resizable=yes,menubar=no,copyhistory=no");
}
</script>
<div id="head">
<div class="linklist">
<?
if ($isLoggedIn) {
	echo "<div class=\"action\"><a href=\"./index.php\">Main</a></div> 
<div class=\"action\"><a href=\"./index.php?mode=setup\">Config</a></div>  
<div class=\"action\"><a href=\"./index.php?mode=reminder\">Reminder</a></div> 
<div class=\"action\"><a href=\"./index.php?mode=cookie\">Cookie</a></div> 
<div class=\"action\"><a href=\"./index.php?mode=about\">About</a></div> 
<div class=\"action\"><a href=\"./index.php?mode=licence\">Licence</a></div>\n";
} else {
	echo "<div class=\"action\"><a href=\"./index.php\">Main</a></div>\n";
}
?>
<div class="clearer">&nbsp;</div>
</div>
<table width="100%"><tr><td><h1><?echo $subtitle;?></h1></td><td><div align="right">
<?
if ($isLoggedIn) { 
	echo "<a href=\"./index.php?mode=logout\">Logout</a>";
} else {
	echo loginform("right",$DEMO);
}
?>
</div></td></tr></table>
</div>
<div id="main">
<?
if ($mode=="setup") {
	include ("./Php/setup.inc.php");
	setup();
} else if ($mode=="reminder") {
	include ("./Php/reminder.inc.php");
	reminder();
} else if ($mode=="cookie") {
  include ("./Php/setcookie.inc.php");
  showSetCookie(); 
} else if ($mode=="about") {
  include ("./Php/about.inc.php");
} else if ($mode=="licence") {
  include ("./Php/licence.inc.php");
} else if ($mode=="stats") {
  include ("./Php/showStats.inc.php"); 
  echoStatsMain();
} else {
	include ("./Php/main.inc.php");
	echomain();
}
?>
</div>
<div class="clearer">&nbsp;</div>
<div id='sign'><a href="http://soft.zoneo.net/phpTrafficA/">phpTrafficA</a> <?echo $version;?> &copy; 2004-2006, ZoneO-soft
<?
$duration = number_format (getmicrotime()-$timestart, 2);
echo " -- $duration sec";
?>
</div>
</body>
</html>
<?
// Dumps the cache
//ob_end_flush();
?>